namespace GridPoc.DataTypes
{
	internal class RichMeasurement : Measurement
	{
		private string poolName;
		private string segmentName;

		public RichMeasurement() {}

		public RichMeasurement(decimal value1,
		                       decimal value2,
		                       decimal value3,
		                       decimal value4,
		                       string poolName,
		                       string segmentName,
													string measurementName)
			: base(measurementName, value1, value2, value3, value4)
		{
			this.poolName = poolName;
			this.segmentName = segmentName;
		}

		public string SegmentName
		{
			get { return segmentName; }
			set { segmentName = value; }
		}
		public string PoolName
		{
			get { return poolName; }
			set { poolName = value; }
		}

		public bool Equals(RichMeasurement other)
		{
			if (ReferenceEquals(null, other)) return false;
			if (ReferenceEquals(this, other)) return true;
			return base.Equals(other) && Equals(other.poolName, poolName) && Equals(other.segmentName, segmentName);
		}

		public override bool Equals(object obj)
		{
			if (ReferenceEquals(null, obj)) return false;
			if (ReferenceEquals(this, obj)) return true;
			return Equals(obj as RichMeasurement);
		}

		public override int GetHashCode()
		{
			unchecked
			{
				int result = base.GetHashCode();
				result = (result * 397) ^ (poolName != null
				                           	? poolName.GetHashCode()
				                           	: 0);
				result = (result * 397) ^ (segmentName != null
				                           	? segmentName.GetHashCode()
				                           	: 0);
				return result;
			}
		}
	}
}